//-----------------------------------------------------
//  Rȓȉ~֐Ɠ꒵т̕RvZ
// http://fuchino.ddo.jp/yatsugatake/ellipticx.pdf
// http://www.wannyan.net/scidog/ellipse/ellipse.pdf
//-----------------------------------------------------
unit Main;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.ExtCtrls, VclTee.TeeGDIPlus,
  VCLTee.TeEngine, VCLTee.Series, VCLTee.TeeProcs, VCLTee.Chart;

type
  TForm1 = class(TForm)
    LabeledEdit10: TLabeledEdit;
    LabeledEdit11: TLabeledEdit;
    Memo1: TMemo;
    nawaBtn: TButton;
    Chart1: TChart;
    Series1: TLineSeries;
    Series2: TPointSeries;
    Xpoint_Edit: TLabeledEdit;
    Ypoint_Edit: TLabeledEdit;
    LabeledEdit1: TLabeledEdit;
    CheckBox1: TCheckBox;
    Label1: TLabel;
    Series3: TPointSeries;
    Series4: TLineSeries;
    Series5: TLineSeries;
    procedure nawaBtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure CheckBox1KeyPress(Sender: TObject; var Key: Char);
  private
    { Private 錾 }
    function jacobi_sn(u, k: double): double;
    function invertK(L, a2: double): double;
    procedure tangent(a, b, c, k, xp, yp: double);
    procedure Linedraw(a0, a1, c0, c1: double; RF, LF: boolean);
    procedure Complete_Elliptic_Integrals(k: double; var Fk, Ek: double);
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses Math;


var
  Ns : integer;
  DBL_EPSILON : double;

// 튮Sȉ~ϕ
// K S
// Fk 
// Ek 
procedure TForm1.Complete_Elliptic_Integrals(k: double; var Fk, Ek: double);
const
  KN = 30;
var
  m     : double;     // the parameter of the elliptic function m = k^2
  a     : double;     // arithmetic mean
  g     : double;     // geometric mean
  a_old : double;     // previous arithmetic mean
  g_old : double;     // previous geometric mean
  two_n : integer;    // power of 2
  sum   : double;
  half  : double;
  N     : integer;    // loop
begin
  half := 1 / 2;
  if k = 0 then begin
    Fk := PI / 2;
    Ek := Fk;
    exit;
  end;
  m := k * k;
  if m = 1 then begin
    Fk := infinity;
    Ek := 1;
    exit;
  end;
  a := 1;
  g := sqrt(1 - m);
  two_n := 1;
  sum := (2 - m);
  N := 0;
  while N < KN do begin     // ȂKNŏI
    g_old := g;
    a_old := a;
    a := (g_old + a_old) * half;
    g := sqrt(g_old * a_old);
    two_n := two_n + two_n;
    sum := sum - two_n * (a * a - g * g);
    if abs(a_old - g_old) <= a_old * DBL_EPSILON then break;
    inc(N);
  end;
  Fk := PI / 2 / a;
  Ek := PI / 4 / a * sum;
end;

// Jacobi֐ Jacobi sn(u, k)
function TForm1.Jacobi_sn(u, k: double): double;
const
  KN = 30;
var
  a: array of double;
  g: array of double;
  c: array of double;
  two_n   : integer;
  phi     : double;
  half    : double;
  i, j, N : integer;
begin
  half := 1 / 2;
  if k = 0 then begin
    result := sin(u);
    exit;
  end;
  if k = 1 then begin
    result := sin(2 * arctan(exp(u)) - pi / 2);
    exit;
  end;
  N := 1;
  setlength(a, N);
  setlength(g, N);
  setlength(c, N);
  a[0] := 1;
  g[0] := sqrt(1 - k * k);
  c[0] := k;
  two_n := 1;
  for i := 0 to KN do begin         // ȂKNŏI
    if abs(a[i] - g[i]) < a[i] * DBL_EPSILON then break;
    two_n := two_n + two_n;
    inc(N);
    setlength(a, N);
    setlength(g, N);
    setlength(c, N);
    a[i + 1] := half * (a[i] + g[i]);
    g[i + 1] := sqrt(a[i] * g[i]);
    c[i + 1] := half * (a[i] - g[i]);
  end;
  Ns := i;
  phi := two_n * a[i] * u;
  for j := i downto 1 do
    phi := half * (phi + arcsin(c[j] * sin(phi) / a[j]));
  result := sin(phi);
end;

// cǩvZ
// L=4a/k'^2*E/K-2aaLmȂ̂k̒l߂܂B
function TForm1.invertK(L, a2: double): double;
const
  KN = 500;
var
  c, fc     : double;
  k, E, Fk  : double;
  dk        : double;
  N         : integer;
begin
  a2 := abs(a2);
  c := (L + a2) / a2 / 2;                     // L=4a/k'^2*E/K-2a 画pŒlvZ
  k := 0;                                     // Sl
  dk := 1 / 2;                                // k
  N := 0;
  repeat
    inc(N);
    k := k + dk;                              // k+k
    if k >= 1 then k := 1 - DBL_EPSILON;      // k1ɐ1͂ɏ܂B
    Complete_Elliptic_Integrals(k, Fk, E);
    fc := E / Fk / (1 - k * k);               // rlvZ
    if fc > c then begin                      // 傫
      k := k - dk;                            // kZ
      dk := dk / 2;                           // k@21
    end;
  until (dk < DBL_EPSILON * k) or (N > KN);   // 
  memo1.Lines.Add('cvZ[v N = ' + intTostr(N));
  result := k;
end;

// ڐ̕`
// a0, a1 ڐ̌X
// c0, c1 ڐ̐ؕ
procedure TForm1.Linedraw(a0, a1, c0, c1: double; RF, LF: boolean);
const
  KN = 200;
var
  t, b, l, r: double;
  w         : double;
  x, dx, y  : double;
  i         : integer;
begin
  if not RF and not LF then exit;
  t := Series2.YValue[0];       // Ot
  b := Series2.YValue[1];       // Ot
  l := Series2.XValue[1];       // Ot
  r := Series2.XValue[2];       // OtE
  w := r - l;                   // 
  dx := w / KN;                 // `Ԋu
  for i := 0 to KN do begin
    x := i * dx + l;
    if LF then begin
      y := a0 * x + c0;
      if (y < t) and (y > b) then Series4.AddXY(x, y);
    end;
    if RF then begin
      y := a1 * x + c1;
      if (y < t) and (y > b) then Series5.AddXY(x, y);
    end;
  end;
end;

// ڐ̌vZ
// a ꒵т̊Ԋu̓񕪂̈ 90
// b R̍
// c ŘW ([_̌Xb/c)
// xp, yp ʉߓ_̍W
procedure TForm1.tangent(a, b, c, k, xp, yp: double);
const
  KN = 100;
var
  alpha     : double;                                 // [_XΊp
  La, Ra    : double;                                 // X
  LF, RF    : boolean;                                // ڐLtO
  yc, u     : double;
  snuk      : double;
  sn2uk     : double;
  x, y, dx  : double;
  N         : integer;
  Salpha    : double;                                 // ̌X
  a0, a1    : double;                                 // ڐ̌X
  c0, c1    : double;                                 // ڐ̐ؕ
begin
  // ړ_邩mF
  alpha := b / c;
  yc := 0;
  if (xp > -a) and (a > xp) then begin                // xp̍WԊuȂ ycvZ
    u := (xp + a) / c;                                // F(,k)=u  u [(x + a)
    snuk := jacobi_sn(u, k);                          // jacobi_sn  Rȓȉ~֐
    yc := snuk * b;                                   // xʒuy̒l
  end;
  La := Maxdouble;                                    // őlZbg̑
  Ra := -La;                                          // ŏlZbg-̑
  LF := False;
  RF := False;
  if yp > yc then begin                               // ycyp傫ꍇ
    if xp <> -a then La := yp / (xp + a);             // [_̌XΌvZ
    if xp <> a  then Ra := yp / (xp - a);             // E[_̌XΌvZ
    if (La <  alpha) and (Xp > -a) then LF := True;   // ̌X΂[_̌X΂菬ꍇTrue
    if (Ra > -alpha) and (Xp <  a) then RF := True;   // ĚX΂[_̌X΂菬ꍇTrue
  end;
  if (yp <= 0) then begin                             // yp[菬ꍇ
    if xp < -a then La := yp / (xp + a);              // [_̌XΌvZ
    if xp > a  then Ra := yp / (xp - a);              // E[_̌XΌvZ
    if (La <  alpha) and (Xp < -a) then RF := True;   // [_̌X΂ꍇETrue
    if (Ra > -alpha) and (Xp >  a) then LF := True;   // E[_̌X΂ꍇTrue
  end;
  // ړ_ړ_ʒǔvZ
  dx := a * 2 / KN;                                   // x=a2/KN
  N := 0;
  x := 0;
  a0 := 0;
  if LF then begin                                    // [ڐʒu
    repeat
      x := x + dx;                                    // xʒu
      u := x / c;                                     // F(,k)=u
      snuk := jacobi_sn(u, k);                        // jacobi_sn  Rȓȉ~֐
      y := snuk * b;                                  // xʒuy̒l
      sn2uk := snuk * snuk;
      alpha := b / c * sqrt((1 - sn2uk) * (1 - k * K * sn2uk)); // RȐ̌X
      Salpha := (yp - y) / (xp - (x - a ));           // ̌X
      if x > a then alpha := -alpha;                  // lvX݂̂Ȃ̂X̒l-ݒ
      if Salpha > alpha then begin                    // ̌X΂Ȑ̌X΂傫Ȃ
        x := x - dx;                                  // x̒l߂
        dx := dx / 2;                                 // dx񕪂̈
        N := 0;                                       // Z񐔃NA
      end
      else inc(N);
    until (N > KN) or (dx < DBL_EPSILON * x);
    Series3.AddXY(x - a, y);                          // ʉߎw_
    a0 := Salpha;                                     // ڐP̌X
  end;
  dx := a * 2 / KN;                                   // x=a2/KN
  N := 0;
  x := 0;
  a1 := 0;
  if RF then begin                                    // E[ڐʒu
    repeat
      x := x + dx;                                    // xʒu
      u := (a + a - x) / c;                           // F(,k)=u
      snuk := jacobi_sn(u, k);                        // jacobi_sn  Rȓȉ~֐
      y := snuk * b;                                  // xʒuy̒l
      sn2uk := snuk * snuk;
      alpha := b / c * sqrt((1 - sn2uk) * (1 - k * K * sn2uk)); // RȐ̌X
      Salpha := (yp - y) / (xp - (a - x));            // ̌X
      if (a + a - x) > a then alpha := -alpha;        // lvX݂̂Ȃ̂X̒l-ݒ
      if Salpha < alpha then begin                    // ̌X΂Ȑ̌X΂菬Ȃ
        x := x - dx;                                  // x̒l߂
        dx := dx / 2;                                 // dx񕪂̈
        N := 0;                                       // Z񐔃NA
      end
      else inc(N);                                    // Z
    until (N > KN) or (dx < DBL_EPSILON * x);         // Z񐔂𒴂閔dxwl菬Ȃ
    Series3.AddXY((a - x), y);                        // ʉߎw_
    a1 := Salpha;                                     // ڐQ̌X
  end;
  c0 := 0;
  if (abs(xp) = a) and (yp = 0) then begin            // w_[_Ȃ
    if xp < 0 then begin
      a0 := alpha;
      LF := True;
    end
    else begin
      a1 := -alpha;
      RF := True;
    end;
  end;
  if LF then memo1.Lines.Add('ڐvZJn_ ');
  if RF then memo1.Lines.Add('ڐvZJn_ E');
  if not LF and not RF then memo1.Lines.Add('ڐ');
  if LF then begin
    c0 := yp - a0 * xp;                               // ؕЂ̌vZ
    memo1.Lines.Add('y=' + floatTostrF(a0,fffixed, 10,5) + 'x + ' + floatTostrF(c0,fffixed, 10,5));
  end;
  c1 := 0;
  if RF then begin
    c1 := yp - a1 * xp;                               // ؕЂ̌vZ
    memo1.Lines.Add('y=' + floatTostrF(a1,fffixed, 10,5) + 'x + ' + floatTostrF(c1,fffixed, 10,5));
  end;
  Linedraw(a0, a1, c0, c1, RF, LF);                   // ڐ̕`
end;

// ꒵т̓o݌vZ
procedure TForm1.nawaBtnClick(Sender: TObject);
const
  kN  = 400;
var
  k         : double;
  ch        : integer;
  a, a2     : double;
  b, u      : double;
  c, L      : double;
  i         : integer;
  x, y, dx  : double;
  snuk      : double;
  ty, by    : double;
  lx, rx    : double;
  def, ddf  : double;
  Ek, Fk    : double;
  Lk        : double;
  xp, yp    : double;
  xmax, xmin : double;
  ymax, ymin : double;
begin
  Ns := 0;                    // sn(u,k)[v
  k := 0;                     // S
  L := 0;                     // R
  val(Labelededit10.Text, a2, ch);
  if ch <> 0 then begin
    application.MessageBox('꒵ѕRxԂɊԈႢ܂B','',0);
    exit;
  end;
  if a2 <= 0 then begin
    application.MessageBox('꒵ѕRxԂ̓[ȏɂĉB','',0);
    exit;
  end;
  val(Xpoint_Edit.Text, xp, ch);
  if ch <> 0 then begin
    application.MessageBox('XW̒lɊԈႢ܂B','',0);
    exit;
  end;
  val(Ypoint_Edit.Text, yp, ch);
  if ch <> 0 then begin
    application.MessageBox('YW̒lɊԈႢ܂B','',0);
    exit;
  end;
  if checkbox1.Checked then begin
    val(LabeledEdit1.Text, k, ch);
    if ch <> 0 then begin
      application.MessageBox('꒵ѕRSjɊԈႢ܂B','',0);
      exit;
    end;
    if k > 1 then begin
      application.MessageBox('k(S)̍ől͂PłB','',0);
      exit;
    end;
    if k < 0 then begin
      application.MessageBox('k(S)̒lɃ}CiX͂܂B','',0);
      exit;
    end;
  end
  else begin
    val(LabeledEdit11.Text, L, ch);
    if ch <> 0 then begin
      application.MessageBox('꒵ѕR̒ɊԈႢ܂B','',0);
      exit;
    end;
    if L <= abs(a2) then begin
      application.MessageBox('R͎̒xԂ蒷ĂB','',0);
      exit;
    end;
  end;
  memo1.Clear;
  if not checkbox1.Checked then begin
    memo1.Lines.Add('R̒(L=' + floatTostr(L) + ')wvZ');
    k := invertK(L, a2);                                    // cǩvZ
    memo1.Lines.Add('c@@@@ @@@  k = ' + floatTostrF(k, ffFixed, 10, 5));
  end
  else
    memo1.Lines.Add('S(k=' + floatTostr(k) + ')wvZ');
  Complete_Elliptic_Integrals(k, Fk, Ek);                   // 튮Sϕ
  if abs(k) = 1 then begin
    application.MessageBox('S̐ΒlPłPȉɂĉB','',0);
    exit;
  end;
  if abs(k) = 0 then begin
    application.MessageBox('S[łB','',0);
    exit;
  end;
  // evZ
  a := a2 / 2;
  c := a / Fk;                                              // ϕlɑ΂ȐW
  b := 2 * k / (1 - k * k) * c;                             // ől ̈ʒu
  memo1.Lines.Add('ȐW@@@@@@  c = ' + floatTostrF(c, ffFixed, 10, 5));
  memo1.Lines.Add('R̒S@ @@@ b = ' + floatTostrF(b, ffFixed, 10, 5));
  // R̒vZ ԈʒǔvZ͏o܂
  if checkbox1.Checked then begin
    Complete_Elliptic_Integrals(k, Fk, Ek);                 // 튮Sϕ
    Lk := 4 * c * Ek / (1 - k * k) - a2;                    // ʂ̒vZ
    memo1.Lines.Add('R̒@@@@@@@@L = ' + floatTostrF(Lk, ffFixed, 10, 5));
  end;
  Series1.Clear;
  Series2.Clear;
  Series3.Clear;
  Series4.Clear;
  Series5.Clear;
  xmax := a;
  xmin := -a;
  ymax := b;
  ymin := 0;
  if xmax < xp then xmax := xp;
  if xmin > xp then xmin := xp;
  if ymax < yp then ymax := yp;
  if ymin > yp then ymin := yp;

  // OtXP[ݒ
  if (xmax - xmin) > (ymax - ymin) then begin
    ddf := (xmax - xmin) / 10;
    def := ((xmax - xmin) - (ymax - ymin)) / 2;
    ty := ymax + def + ddf;
    by := ymin - def - ddf;
    rx := xmax + ddf;
    lx := xmin - ddf;
  end
  else begin
    ddf := (ymax - ymin) / 10;
    def := ((ymax - ymin) - (xmax - xmin)) / 2;
    ty := ymax + ddf;
    by := ymin - ddf;
    rx := xmax + def + ddf;
    lx := xmin - def - ddf;
  end;
  // Ot̃XP[ݒlZbg
  Series2.AddXY(lx, ty);
  Series2.AddXY(lx, by);
  Series2.AddXY(rx, by);
  application.ProcessMessages;                      // Ot\҂
  // Ot}
  dx := a / KN;                                     // X
  // 0`KN@vZ}
  for i := -KN to KN do begin
    x := i * dx;                                    // xʒu
    u := (x + a) / c;                               // F(,k)=u  u [(x + a)
    snuk := jacobi_sn(u, k);                        // jacobi_sn  Rȓȉ~֐
    y := snuk * b;                                  // xʒuy̒l
    Series1.AddXY(x, y);                            // Otɒǉ
  end;
  Series3.AddXY(xp, yp);                            // ʉߎw_
  application.ProcessMessages;                      // Ot\҂
  tangent(a, b, c, k, xp, yp);                      // ڐ̌vZ
  Label1.Caption:= 'sn(u) őLoop= ' + intTostr(Ns);
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
  if CheckBox1.Checked then begin
    labeledEdit1.Enabled := True;
    labeledEdit11.Enabled := False;
  end
  else begin
    labeledEdit1.Enabled := False;
    labeledEdit11.Enabled := True;
  end;
end;

procedure TForm1.CheckBox1KeyPress(Sender: TObject; var Key: Char);
begin
  if CheckBox1.Checked then CheckBox1.Checked := False
                       else CheckBox1.Checked := True;
end;

// ݒ
// DBL_EPSILON l̐ݒ  1 + y = 1 y̒lo y = 1E-i
// DBL_EPSILON = y * 2;
procedure TForm1.FormCreate(Sender: TObject);
const
  IM = 50;
var
  x, y, z : double;
  i       : integer;
begin
  labeledEdit1.Enabled := False;
  i := 0;
  x := 1;
  y := 1 / 4194304;                           // 4194304 = 2^22
  repeat
    y := y / 2;
    z := x + y;                               // mFZ
    inc(i);
  until (z = 1) or (i > IM) ;                 // ܂ŌJԂ
  DBL_EPSILON := y * 2;
end;

end.
